Unit GSG1R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, GSU1R_p;

procedure GSG1R(var ISEED :Integer; A :Real; B :Real; var N :Integer;
                var R :Array of Real);

implementation

procedure GSG1R(var ISEED :Integer; A :Real; B :Real; var N :Integer;
                var R :Array of Real);
var
I :Integer;
C1,C3,C4,C5 :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
C1 := 1.0;
if ( A > 5.0 ) 
 then goto _2;
if ( A <= 2.0 ) 
 then goto _1;
_GSG1R1.elm1:= ((((0.82E-6*A-0.581E-4)*A+0.172718E-2)*A-0.2952801E-1)*
 A+0.4583906)*A+0.64350;
goto _3;
_1:
_GSG1R1.elm1:= ((((0.9727925*A-3.950977)*A+6.009148)*A-4.34612)*A+
 2.102998)*A+0.2177;
goto _3;
_2:
_GSG1R1.elm1:= (((-6.E-7*A+0.1623E-4)*A-0.230695E-2)*A+0.2249999)*A+
 1.33408;
_3:
C3 := 1.0+(1.0/_GSG1R1.elm1);
_4:
if ( C3-2.0 ) < 0
 then goto _6
 else if ( C3-2.0 ) > 0
       then goto _5
       else goto _7;
_5:
C3 := C3-1.0;
C1 := C1*C3;
goto _4;
_6:
C4 := C3-1.0;
C5 := ((((((-0.514993E-1*C4+0.2548205)*C4-0.5684729)*C4+
 0.8328212)*C4-0.8764218)*C4+0.985854)*C4-0.560472E-3)*C4+
 1.0;
C1 := C1*C5;
_7:
_GSG1R1.elm2:= 1.0/(Power(C1/(A*B),_GSG1R1.elm1));
_GSG1R1.elm1:= 1.0/_GSG1R1.elm1;
GSU1R(ISEED,N,R);
for I:=1 to N do
 begin
  R[I-1] := Power(((-Ln(R[I-1]))*_GSG1R1.elm2),_GSG1R1.elm1);
_8:
 end;
end;

end.
