Unit GSG3R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, GSB1R_p, GSU1R_p;

procedure GSG3R(var ISEED :Integer; A :Real; B :Real; var N :Integer;
                var W :Array of Real; var R :Array of Real);

implementation

procedure GSG3R(var ISEED :Integer; A :Real; B :Real; var N :Integer;
                var W :Array of Real; var R :Array of Real);
var
IA,N1,I,J :Integer;
A1,B1 :Real;
const
SYS087 :Real = 1.0E-5;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9;
begin
IA := Trunc( A );
A1 := A-IA;
if ( A1 <= SYS087 ) 
 then goto _5;
B1 := 1.0-A1;
if ( B1 <= SYS087 ) 
 then goto _7;
GSB1R(ISEED,A1,B1,N,R);
_1:
N1 := 1+IA;
for I:=1 to N do
 begin
  GSU1R(ISEED,N1,W);
  for J:=1 to N1 do
   begin
    W[J-1] := -Ln(W[J-1]);
_2:
   end;
  A1 := 0.0;
  if ( IA = 0 ) 
   then goto _4;
  for J:=1 to IA do
   begin
    A1 := A1+W[J-1];
_3:
   end;
_4:
  R[I-1] := (A1+R[I-1]*W[N1-1])*B;
 end;
goto _9;
_5:
for I:=1 to N do
 begin
_6:
  R[I-1] := 0.0;
 end;
goto _1;
_7:
for I:=1 to N do
 begin
_8:
  R[I-1] := 1.0;
 end;
goto _1;
_9:
end;

end.
